
#include <iostream>
#include <map>
#include <stdexcept>
#include <proj++/stopwatch.hh>

using namespace std;

#include <dimnum/dimnum.hh>
#include <dimnum/si.hh>
#include <dimnum/typesetting.hh>
#include <dimnum/british.hh>
#include <dimnum/hep.hh>
#include <dimnum/constants.hh>

int main()
	{
	try {
		cout << tex::point << endl;

		dn::length<double, unit::inch>        linch(1);
		dn::length<double, unit::centimeter>  lcm(1);

		cout << linch.value << std::endl;
		cout << lcm.value << std::endl;
		cout << linch << std::endl;
		cout << lcm << std::endl << std::endl;
		lcm=linch;
		cout << lcm << std::endl << std::endl;

		si::time<long> secs1, secs2;

		secs1=1*si::second;
		secs2=3*si::second;
		cout << "4 seconds? " << secs1+secs2 << std::endl;

		si::time<> tstsec(3.0);

		british::length<> blen;
		blen=10*tex::point;
		cout << blen << endl;

		cout << tstsec << endl;
		secs1=60;
		cout << secs1 << endl;
		secs1=60*si::hour;
		cout << secs1 << endl;

		class dn::length<double, unit::point> ll1(3.0);
		class si::time<float>            t1(3.0);
		class si::area<float>            a;
      class si::velocity<float>        v;
      class si::time<float>            tim(2.0);
		class british::length<double, unit::foot>    l1(2.0);
		class british::length<double>    l2(3);
		
      v=l1/tim;

		cout << "known abbreviations:" << endl;
		map<string, set7>::iterator it=s2d.begin(), eit=s2d.end();
		while(it!=eit) {
			cout << (*it).first << "\t" << (*it).second.n << "/" << (*it).second.d;
			if((*it).second.p!=0) cout << " 10^{" << (*it).second.p << "}";
			cout << endl;
			++it;
			}
		cout << endl;
		

//	l2=l1+l1;
		// 5.36285e-06mm
		cout << si::meter << ", " << consts::g << ", " << consts::h << ", " << consts::k << endl;
		cout << hep::GeV << "=" << si::energy<>(hep::GeV) << endl;
		cout << hep::mass<>(1.0) << "=" << si::mass<>(hep::mass<>(1.0)) << endl;

//  This is not possible:
//		class dn::length<double, si::meter> fik;

		cout << si::length<double, unit::millimeter>(tex::length<double>(1)) << endl;
		a=l2*l1*l1/l2;
		cout << l2 << endl;
		cout << a << endl;
		cout << l1*l2 << endl;
		
		si::area<double, unit::metersquared> l1timesl2(l1*l2);
		cout << l1timesl2 << std::endl;

		cout << "Enter a length and press CTRL-D: " << std::flush;
		cin >> l2;
		cout << l2 << endl;
//	  cout << units::area<float, si::milli>(l1*l2) << endl;
//	  cout << l1/t1 << endl;
//	cout << units::length<double, british::inch>(l2) << endl;
		}
	catch(exception& ex) {
		cerr << ex.what() << endl;
		}
	}
