
#include <dimnum/dimnum.hh>
#include <dimnum/si.hh>
#include <iostream>
#include <proj++/stopwatch.hh>
#include <vector>

main()
	{
// Test size:

   std::cout << "size: " << sizeof(double) << " bytes versus " 
		  << sizeof(si::length<double>) << " bytes" << std::endl;

// Test runtime speed overhead:

	std::cout << "simple assignment:" << std::endl;
	stopwatch sw;
	sw.start();
	std::vector<double> tmp1;
	for(unsigned long i=0; i<4000000L; ++i) {
		tmp1.push_back(i);
		}
	sw.stop();
	std::cout << "  using plain doubles : " << sw << std::endl;
	sw.reset();
	sw.start();
	std::vector<si::length<double> > tmp2;
	for(unsigned long i=0; i<4000000L; ++i) {
		tmp2.push_back(i); 
		}
	sw.stop();
	std::cout << "  using dimnum doubles: " << sw << std::endl;


	tmp1.clear();
	tmp2.clear();
// Test with multiplications

	std::cout << "multiplication:" << std::endl;
	sw.reset();
	sw.start();
	double a2;
	for(unsigned long i=0; i<4000000L; ++i) {
		double a1=i;
		a2=i+1;
		tmp1.push_back(a1*a2);
		}
	sw.stop();
	std::cout << "  using plain doubles : " << sw << std::endl;
	sw.reset();
	sw.start();
	double b2;
	for(unsigned long i=0; i<4000000L; ++i) {
		si::length<double> b1(i);
		b2=i+1;
		tmp2.push_back(b2*b1);
		}
	sw.stop();
	std::cout << "  using dimnum doubles: " << sw << std::endl;
	

	// operator= is slow, because it is not implemented yet.
	}
